
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>How do I … &#8212; crystally 29.03.2020 documentation</title>
    <link rel="stylesheet" href="_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script src="_static/language_data.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="API Reference" href="api_reference.html" />
    <link rel="prev" title="crystally documentation" href="index.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <div class="section" id="how-do-i">
<h1>How do I …<a class="headerlink" href="#how-do-i" title="Permalink to this headline">¶</a></h1>
<div class="section" id="install-crystally">
<h2>… install crystally?<a class="headerlink" href="#install-crystally" title="Permalink to this headline">¶</a></h2>
<p><code class="xref py py-mod docutils literal notranslate"><span class="pre">crystally</span></code> is obtainable via pip. To install the package simply type:</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>python3 -m pip install crystally <span class="o">[</span>--user<span class="o">]</span>
</pre></div>
</div>
<p>After this step you can import crystally:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">crystally</span>
</pre></div>
</div>
</div>
<div class="section" id="create-a-lattice">
<h2>… create a lattice?<a class="headerlink" href="#create-a-lattice" title="Permalink to this headline">¶</a></h2>
<p>To create a lattice, you need to specify the cartesian lattice vectors and the atoms with their fractional coordinates.
An atom has three attributes: an element, a position and a sublattice. The last of these attributes is more of a
wildcard, to help with sorting or filtering operations.</p>
<p>The ceria system is then easily created by:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">crystally</span> <span class="kn">import</span> <span class="n">Lattice</span><span class="p">,</span> <span class="n">Atom</span>
<span class="n">ceria</span> <span class="o">=</span> <span class="n">Lattice</span><span class="p">(</span><span class="n">vectors</span> <span class="o">=</span> <span class="p">[[</span><span class="mf">5.499</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">],</span> <span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mf">5.499</span><span class="p">,</span> <span class="mi">0</span><span class="p">],</span> <span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mf">5.499</span><span class="p">]],</span>
                <span class="n">atoms</span> <span class="o">=</span> <span class="p">[</span><span class="n">Atom</span><span class="p">(</span><span class="s2">&quot;Ce&quot;</span><span class="p">,</span> <span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">],</span> <span class="s2">&quot;cations&quot;</span><span class="p">),</span>
                         <span class="n">Atom</span><span class="p">(</span><span class="s2">&quot;Ce&quot;</span><span class="p">,</span> <span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mf">0.5</span><span class="p">,</span> <span class="mf">0.5</span><span class="p">],</span> <span class="s2">&quot;cations&quot;</span><span class="p">),</span>
                         <span class="n">Atom</span><span class="p">(</span><span class="s2">&quot;Ce&quot;</span><span class="p">,</span> <span class="p">[</span><span class="mf">0.5</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mf">0.5</span><span class="p">],</span> <span class="s2">&quot;cations&quot;</span><span class="p">),</span>
                         <span class="n">Atom</span><span class="p">(</span><span class="s2">&quot;Ce&quot;</span><span class="p">,</span> <span class="p">[</span><span class="mf">0.5</span><span class="p">,</span> <span class="mf">0.5</span><span class="p">,</span> <span class="mi">0</span><span class="p">],</span> <span class="s2">&quot;cations&quot;</span><span class="p">),</span>
                         <span class="n">Atom</span><span class="p">(</span><span class="s2">&quot;O&quot;</span><span class="p">,</span> <span class="p">[</span><span class="mf">0.25</span><span class="p">,</span> <span class="mf">0.25</span><span class="p">,</span> <span class="mf">0.25</span><span class="p">],</span> <span class="s2">&quot;anions&quot;</span><span class="p">),</span>
                         <span class="n">Atom</span><span class="p">(</span><span class="s2">&quot;O&quot;</span><span class="p">,</span> <span class="p">[</span><span class="mf">0.75</span><span class="p">,</span> <span class="mf">0.25</span><span class="p">,</span> <span class="mf">0.25</span><span class="p">],</span> <span class="s2">&quot;anions&quot;</span><span class="p">),</span>
                         <span class="n">Atom</span><span class="p">(</span><span class="s2">&quot;O&quot;</span><span class="p">,</span> <span class="p">[</span><span class="mf">0.25</span><span class="p">,</span> <span class="mf">0.75</span><span class="p">,</span> <span class="mf">0.25</span><span class="p">],</span> <span class="s2">&quot;anions&quot;</span><span class="p">),</span>
                         <span class="n">Atom</span><span class="p">(</span><span class="s2">&quot;O&quot;</span><span class="p">,</span> <span class="p">[</span><span class="mf">0.25</span><span class="p">,</span> <span class="mf">0.25</span><span class="p">,</span> <span class="mf">0.75</span><span class="p">],</span> <span class="s2">&quot;anions&quot;</span><span class="p">),</span>
                         <span class="n">Atom</span><span class="p">(</span><span class="s2">&quot;O&quot;</span><span class="p">,</span> <span class="p">[</span><span class="mf">0.75</span><span class="p">,</span> <span class="mf">0.75</span><span class="p">,</span> <span class="mf">0.25</span><span class="p">],</span> <span class="s2">&quot;anions&quot;</span><span class="p">),</span>
                         <span class="n">Atom</span><span class="p">(</span><span class="s2">&quot;O&quot;</span><span class="p">,</span> <span class="p">[</span><span class="mf">0.25</span><span class="p">,</span> <span class="mf">0.75</span><span class="p">,</span> <span class="mf">0.75</span><span class="p">],</span> <span class="s2">&quot;anions&quot;</span><span class="p">),</span>
                         <span class="n">Atom</span><span class="p">(</span><span class="s2">&quot;O&quot;</span><span class="p">,</span> <span class="p">[</span><span class="mf">0.75</span><span class="p">,</span> <span class="mf">0.25</span><span class="p">,</span> <span class="mf">0.75</span><span class="p">],</span> <span class="s2">&quot;anions&quot;</span><span class="p">),</span>
                         <span class="n">Atom</span><span class="p">(</span><span class="s2">&quot;O&quot;</span><span class="p">,</span> <span class="p">[</span><span class="mf">0.75</span><span class="p">,</span> <span class="mf">0.75</span><span class="p">,</span> <span class="mf">0.75</span><span class="p">],</span> <span class="s2">&quot;anions&quot;</span><span class="p">)])</span>
</pre></div>
</div>
<p>We will use this system in the following explanations.</p>
</div>
<div class="section" id="view-the-lattice">
<h2>… view the lattice?<a class="headerlink" href="#view-the-lattice" title="Permalink to this headline">¶</a></h2>
<p>To get a nicely readable representation of the lattice simply use the print command:</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">ceria</span><span class="p">)</span>
<span class="go">Lattice:</span>
<span class="go">     Vectors:</span>
<span class="go">           5.4994687617  0.0000000000  0.0000000000</span>
<span class="go">           0.0000000000  5.4994687617  0.0000000000</span>
<span class="go">           0.0000000000  0.0000000000  5.4994687617</span>
<span class="go">     Positions:</span>
<span class="go">          0    Atom: Ce    [ 0.0000000000,  0.0000000000,  0.0000000000]  cations</span>
<span class="go">          1    Atom: Ce    [ 0.0000000000,  0.5000000000,  0.5000000000]  cations</span>
<span class="go">          2    Atom: Ce    [ 0.5000000000,  0.0000000000,  0.5000000000]  cations</span>
<span class="go">          3    Atom: Ce    [ 0.5000000000,  0.5000000000,  0.0000000000]  cations</span>
<span class="go">          4    Atom: O     [ 0.2500000000,  0.2500000000,  0.2500000000]  anions</span>
<span class="go">          5    Atom: O     [ 0.7500000000,  0.2500000000,  0.2500000000]  anions</span>
<span class="go">          6    Atom: O     [ 0.2500000000,  0.7500000000,  0.2500000000]  anions</span>
<span class="go">          7    Atom: O     [ 0.2500000000,  0.2500000000,  0.7500000000]  anions</span>
<span class="go">          8    Atom: O     [ 0.7500000000,  0.7500000000,  0.2500000000]  anions</span>
<span class="go">          9    Atom: O     [ 0.2500000000,  0.7500000000,  0.7500000000]  anions</span>
<span class="go">          10   Atom: O     [ 0.7500000000,  0.2500000000,  0.7500000000]  anions</span>
</pre></div>
</div>
</div>
<div class="section" id="create-a-supercell">
<h2>… create a supercell?<a class="headerlink" href="#create-a-supercell" title="Permalink to this headline">¶</a></h2>
<p>After defining your unitcell, you may want to create a larger supercell. This is pretty easy. In the following example
we want to create a ceria supercell of size 2x2x2:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">supercell</span> <span class="o">=</span> <span class="n">Lattice</span><span class="o">.</span><span class="n">from_lattice</span><span class="p">(</span><span class="n">ceria</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="mi">2</span><span class="p">)</span>
</pre></div>
</div>
<p>As you see, the function <code class="xref py py-meth docutils literal notranslate"><span class="pre">from_lattice()</span></code> takes four arguments. The first one is the base lattice that is taken
as starting point. The three following values describe the size multiplier for each direction: x, y and z.</p>
</div>
<div class="section" id="select-an-atom">
<h2>… select an atom?<a class="headerlink" href="#select-an-atom" title="Permalink to this headline">¶</a></h2>
<p>The index-method of the lattice objects returns the atom from the atom list with the provided index:</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">ceria</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
<span class="go">Atom(&#39;Ce&#39;,FractionalVector([0.0, 0.0, 0.0]),&#39;Ce&#39;)</span>
</pre></div>
</div>
<p>You can also search for atoms with the <code class="xref py py-meth docutils literal notranslate"><span class="pre">find()</span></code>-method. You can specify the element, sublattice and the position
in fractinoal coordinatesof the atoms to search for. Mind that only one argument is allowed for each criteria.
In addition you can specify thetolerance for the positional criteria in angstrom. If the distance between
the specified position and the atom is smaller than the tolerance, it will be found. Let’s say that you want to find
the atom that is located at 0, 0, 0:</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">caria</span><span class="o">.</span><span class="n">find</span><span class="p">(</span><span class="n">position</span><span class="o">=</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">])</span>
<span class="go">[Atom(&#39;Ce&#39;,FractionalVector([0.0, 0.0, 0.0]),&#39;Ce&#39;)]</span>
</pre></div>
</div>
<p>The return value is always a list, unless you set first=True. Then the first found atom is returned:</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">caria</span><span class="o">.</span><span class="n">find</span><span class="p">(</span><span class="n">position</span><span class="o">=</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">],</span> <span class="n">first</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="go">Atom(&#39;Ce&#39;,FractionalVector([0.0, 0.0, 0.0]),&#39;Ce&#39;)</span>
</pre></div>
</div>
</div>
<div class="section" id="create-a-vacancy">
<h2>… create a vacancy?<a class="headerlink" href="#create-a-vacancy" title="Permalink to this headline">¶</a></h2>
<p>To delete entries from the atom list of a lattice, you can use the <code class="xref py py-meth docutils literal notranslate"><span class="pre">remove()</span></code>-method. You need to specify
an atom that really is in the atom list of the lattice. Otherwise a <code class="xref py py-exc docutils literal notranslate"><span class="pre">ValueError</span></code> is raised.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">supercell</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">supercell</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
</pre></div>
</div>
</div>
<div class="section" id="get-the-distance-between-two-points-in-the-lattice">
<h2>… get the distance between two points in the lattice?<a class="headerlink" href="#get-the-distance-between-two-points-in-the-lattice" title="Permalink to this headline">¶</a></h2>
<p>Every lattice object comes with a <code class="xref py py-meth docutils literal notranslate"><span class="pre">distance()</span></code> method. If you specify two points in fractional coordinates or
two atoms, it will return the distance between the two points in angstrom. This will take the periodic boundary
into consideration. You can turn this off by setting <code class="docutils literal notranslate"><span class="pre">`periodic=False`</span></code>.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">supercell</span><span class="o">.</span><span class="n">distance</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">],</span> <span class="p">[</span><span class="mf">0.8</span><span class="p">,</span> <span class="mf">0.8</span><span class="p">,</span> <span class="mf">0.8</span><span class="p">])</span>
<span class="go">3.8101437239430154</span>
</pre></div>
</div>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">supercell</span><span class="o">.</span><span class="n">distance</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">],</span> <span class="p">[</span><span class="mf">0.8</span><span class="p">,</span> <span class="mf">0.8</span><span class="p">,</span> <span class="mf">0.8</span><span class="p">],</span> <span class="n">periodic</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
<span class="go">15.240574895772065</span>
</pre></div>
</div>
</div>
<div class="section" id="change-the-position-of-an-atom">
<h2>… change the position of an atom?<a class="headerlink" href="#change-the-position-of-an-atom" title="Permalink to this headline">¶</a></h2>
<p><code class="xref py py-mod docutils literal notranslate"><span class="pre">crystally</span></code> was created with the intend to manipulate lattices. Changing the position of an atom is therefore
very simple. First select the atom you would like to manipulate. Then change the <code class="xref py py-attr docutils literal notranslate"><span class="pre">position</span></code> attribute:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">atom</span> <span class="o">=</span> <span class="n">lattice</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
<span class="n">atom</span><span class="o">.</span><span class="n">position</span> <span class="o">=</span> <span class="p">[</span><span class="mf">0.1</span><span class="p">,</span> <span class="mf">0.1</span><span class="p">,</span> <span class="mf">0.1</span><span class="p">]</span>
</pre></div>
</div>
</div>
<div class="section" id="increase-the-distance-between-two-atoms">
<h2>… increase the distance between two atoms?<a class="headerlink" href="#increase-the-distance-between-two-atoms" title="Permalink to this headline">¶</a></h2>
<p>If you want to increase the distance of one point to a fixed center point you can either use <code class="xref py py-meth docutils literal notranslate"><span class="pre">increase_distance_abs()</span></code>
or <code class="xref py py-meth docutils literal notranslate"><span class="pre">increase_distance_rel()</span></code> from the <code class="xref py py-class docutils literal notranslate"><span class="pre">Lattice</span></code> object. Both methods return the new position. With the first
method you can specify the distance increase as absolute value in angstrom. The second method increases the distance
on a relative basis.</p>
<p>Examples:
To increase the distance of a point at (0.5, 0.5, 0.5) from the origin by 1 Angstrom, do:</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">supercell</span><span class="o">.</span><span class="n">increase_distance_abs</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">],</span> <span class="p">[</span><span class="mf">0.5</span><span class="p">,</span> <span class="mf">0.5</span><span class="p">,</span> <span class="mf">0.5</span><span class="p">],</span> <span class="mi">1</span><span class="p">))</span>
<span class="go">[0.55249146 0.55249146 0.55249146]</span>
</pre></div>
</div>
</div>
<div class="section" id="read-and-write-vasp-files">
<h2>… read and write vasp files?<a class="headerlink" href="#read-and-write-vasp-files" title="Permalink to this headline">¶</a></h2>
<p>To read a POSCAR or CONTCAR file, you can use the <code class="xref py py-func docutils literal notranslate"><span class="pre">read_poscar()</span></code> function. For example, if you would like to
read the file “POSCAR”, type:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">crystally</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">lattice</span> <span class="o">=</span> <span class="n">crystally</span><span class="o">.</span><span class="n">read_poscar</span><span class="p">(</span><span class="s2">&quot;POSCAR&quot;</span><span class="p">)</span>
</pre></div>
</div>
<p>To write a <code class="xref py py-class docutils literal notranslate"><span class="pre">Lattice</span></code> object to a POSCAR file, use the <code class="xref py py-func docutils literal notranslate"><span class="pre">write_poscar()</span></code> function. You need to specify the
<code class="xref py py-class docutils literal notranslate"><span class="pre">Lattice</span></code> object, the name and location of the file and a short description for the header of the POSCAR file.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">crystally</span><span class="o">.</span><span class="n">write_poscar</span><span class="p">(</span><span class="n">supercell</span><span class="p">,</span> <span class="s2">&quot;POSCAR&quot;</span><span class="p">,</span> <span class="s2">&quot;ceria supercell structure&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="index.html">crystally</a></h1>








<h3>Navigation</h3>
<p class="caption"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="current reference internal" href="#">How do I …</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#install-crystally">… install crystally?</a></li>
<li class="toctree-l2"><a class="reference internal" href="#create-a-lattice">… create a lattice?</a></li>
<li class="toctree-l2"><a class="reference internal" href="#view-the-lattice">… view the lattice?</a></li>
<li class="toctree-l2"><a class="reference internal" href="#create-a-supercell">… create a supercell?</a></li>
<li class="toctree-l2"><a class="reference internal" href="#select-an-atom">… select an atom?</a></li>
<li class="toctree-l2"><a class="reference internal" href="#create-a-vacancy">… create a vacancy?</a></li>
<li class="toctree-l2"><a class="reference internal" href="#get-the-distance-between-two-points-in-the-lattice">… get the distance between two points in the lattice?</a></li>
<li class="toctree-l2"><a class="reference internal" href="#change-the-position-of-an-atom">… change the position of an atom?</a></li>
<li class="toctree-l2"><a class="reference internal" href="#increase-the-distance-between-two-atoms">… increase the distance between two atoms?</a></li>
<li class="toctree-l2"><a class="reference internal" href="#read-and-write-vasp-files">… read and write vasp files?</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="api_reference.html">API Reference</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="index.html">Documentation overview</a><ul>
      <li>Previous: <a href="index.html" title="previous chapter">crystally documentation</a></li>
      <li>Next: <a href="api_reference.html" title="next chapter">API Reference</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2020, John P. Arnold.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 2.4.4</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="_sources/how_do_i.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>